---
title: WritableStream.abort()
slug: Web/API/WritableStream/abort
tags:
  - API
  - Experimental
  - Method
  - Reference
  - Streams
  - WritableStream
  - abort
---
<div>{{draft}}{{SeeCompatTable}}{{APIRef("Streams")}}</div>

<p class="summary">The <strong><code>abort()</code></strong> method of the {{domxref("WritableStream")}} interface aborts the stream, signaling that the producer can no longer successfully write to the stream and it is to be immediately moved to an error state, with any queued writes discarded.</p>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox">var <em>promise</em> = <em>writableStream</em>.abort(<em>reason</em>);</pre>

<h3 id="Parameters">Parameters</h3>

<dl>
 <dt>reason</dt>
 <dd>A {{domxref("DOMString")}} providing a human-readable reason for the abort.</dd>
</dl>

<h3 id="Return_value">Return value</h3>

<p>A {{jsxref("Promise")}}, which fulfills with the value given in the <code>reason</code> parameter.</p>

<h3 id="Exceptions">Exceptions</h3>

<dl>
 <dt>TypeError</dt>
 <dd>The stream you are trying to abort is not a {{domxref("WritableStream")}}, or it is locked.</dd>
</dl>

<h2 id="Examples">Examples</h2>

<pre class="brush: js line-numbers  language-js"><code class="language-js"><span class="keyword token">const</span> writableStream <span class="operator token">=</span> <span class="keyword token">new</span> <span class="class-name token">WritableStream</span><span class="punctuation token">(</span><span class="punctuation token">{</span>
  <span class="function token">write</span><span class="punctuation token">(</span>chunk<span class="punctuation token">)</span> <span class="punctuation token">{</span>
    ...
  <span class="punctuation token">}</span><span class="punctuation token">,</span>
  <span class="function token">close</span><span class="punctuation token">(</span><span class="punctuation token">)</span> <span class="punctuation token">{</span>
    <span class="keyword token">...</span>
  <span class="punctuation token">}</span><span class="punctuation token">,</span>
  <span class="function token">abort</span><span class="punctuation token">(</span>err<span class="punctuation token">)</span> <span class="punctuation token">{</span>
    ...
  <span class="punctuation token">}</span>
<span class="punctuation token">}</span><span class="punctuation token">,</span> queuingStrategy<span class="punctuation token">)</span><span class="punctuation token">;</span>

...

// abort the stream later on, when required
writableStream.abort();
</code>
</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
  <tr>
   <td>{{SpecName("Streams","#ws-abort","abort()")}}</td>
   <td>{{Spec2('Streams')}}</td>
   <td>Initial definition.</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<div class="hidden">
<p>The compatibility table in this page is generated from structured data. If you'd like to contribute to the data, please check out <a href="https://github.com/mdn/browser-compat-data">https://github.com/mdn/browser-compat-data</a> and send us a pull request.</p>
</div>

<p>{{Compat("api.WritableStream.abort")}}</p>
